/*****************************************************************************/
/*                                                                           */
/*   VECTREX HP3000 Software Emulator              Copyright K.Wilkins 1996  */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Title      : VECTREX HP3000 Analog CRT X,Y,Z & Compare Emulation Module */
/*                                                                           */
/*   File Name  : ANALOG.H                                                   */
/*                                                                           */
/*   Author     : Keith Wilkins / C.S.                                       */
/*                                                                           */
/*   Version    : 1.20                                                       */
/*                                                                           */
/*   Desciption : The file contains the definitions and function prototypes  */
/*                for the analog emulation module of the vectrex emulator    */
/*                                                                           */
/*****************************************************************************/
/*                                                                           */
/*   Revision History:                                                       */
/*                                                                           */
/*   Version    Date    Who  Description of changes                          */
/*   -------    ----    ---  ----------------------                          */
/*                                                                           */
/*    0.01    13/03/93  K.W  Creation                                        */
/*    1.00    05/08/96  K.W  Public release of DVE V1.0                      */
/*    1.20    20/10/96  C.S  DVE V1.20                                       */
/*                                                                           */
/*****************************************************************************/

#if !defined ANALOG1_H
    #define ANALOG1_H

extern T_VOID      (* fAnalogTick_linear_shift)(T_VOID);
extern T_VOID      (* fAnalogTick_linear_div)(T_VOID);
extern T_VOID      (* fAnalogTick_bank_shift)(T_VOID);
extern T_VOID      (* fAnalogTick_bank_div)(T_VOID);
extern T_VOID      (* fAnalogTick_linear_shift_lightpen)(T_VOID);
extern T_VOID      (* fAnalogTick_linear_div_lightpen)(T_VOID);
extern T_VOID      (* fAnalogTick_bank_shift_lightpen)(T_VOID);
extern T_VOID      (* fAnalogTick_bank_div_lightpen)(T_VOID);
extern T_VOID      (* fAnalogTick_linear_shift_imager)(T_VOID);
extern T_VOID      (* fAnalogTick_linear_div_imager)(T_VOID);
extern T_VOID      (* fAnalogTick_bank_shift_imager)(T_VOID);
extern T_VOID      (* fAnalogTick_bank_div_imager)(T_VOID);

T_VOID set_analog1_functions(T_INT type);
#endif